unit Unit1;

(* ne pas oublier de modifier
   Form1.Caption
   LiliScore.Theme
*)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Liliscor, LiliPlan, Imageo,
  KeopsPan;

type

  TData = class (* type 1 exo *)
        (* complter par des champs donnes *)
        Hypo,Conc,Figure : TStringList;
        Theo : integer; (* doit tre theoreme.numero *)
        essai : integer; 
        constructor Create;
        Destructor Destroy;
  end;

  TTheoreme = class
        numero : integer; (* numro de l'exo correspondant *)
        enonce : TStringList;
        constructor Create;
        Destructor Destroy;
  end;

  TDataList = class(TList) (* type liste d'exos *)
        (* liste d'objets TData *)
        constructor Create;
        Destructor Destroy;
        procedure MelangeAleatoire;
  end;

  TForm1 = class(TForm) (* fiche *)
    LiliPanel1: TPanel;
    LiliBitBtn1: TBitBtn;
    LiliBitBtn2: TBitBtn;
    LiliBitBtn3: TBitBtn;
    LiliScore1: TLiliScore;
    Panel2: TPanel;
    KeopsPanel1: TKeopsPanel;
    KeopsPanel2: TKeopsPanel;
    Label5: TLabel;
    Panel1: TPanel;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn4: TBitBtn;
    Memo1: TMemo;
    Memo2: TMemo;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel3: TPanel;
    Label4: TLabel;
    Memo3: TMemo;
    Panel5: TPanel;
    Image1: TImage;
    Panel6: TPanel;
    Label6: TLabel;
    Panel7: TPanel;
    Shape1: TShape;
    ImageoPlan1: TImageoPlan;
    procedure LiliBitBtn1Click(Sender: TObject);
    procedure LiliBitBtn2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LiliBitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Dclarations private }
    FirstRun : boolean;
    NbExo : integer;
    MaxExo : integer;
    PointParExo : integer;
    procedure NouvelExo; (* procedure d'aiguillage *)
    procedure Initialise; (* interne *)
  public
    { Dclarations public }
    Credit : integer; (* on perdra des points *)
    DataList : TDataList; (* liste des exos *)
    Data : TData; (* tampon de l'exo en cours : contenu dans DataList !*)
    ParamStr1 : string; (* premier paramtre *)
    Chemin : string; (* chemin actuel avec \ *)
    (* en plus*)
    TheoList : TDataList;  (* liste des theoremes *)
    Theoreme : TTheoreme;  (* theoreme en cours *)
    NumTheos : integer;     (* n du theo dans la liste (<>theoreme.nurmero !*) 
    function Autre : boolean; (* pour indiquer "trop d'essais" *)
    procedure ChargeExo; (* chargement des donnes propres  l'exo *)
    procedure Verifier;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


(******************************************************)
(* LILI: mthodes de base : ne pas modifier (a piori) *)
(******************************************************)

(*********)
(* l'objet TForm1 fiche de base *)
(**********)

procedure TForm1.initialise;
(* appel par FormShow *)
begin
     (* a priori rien  crire ici !
        voir ChargeExo !
     *)

     Data:=nil;
     DataList:=nil;
     (* chemin de l'appli avec \ final *)
     chemin:=ExtractFilePath(Application.exeName);
     if chemin[length(chemin)]<>'\' then chemin:=chemin+'\';

     randomize;
     DataList:=TDataList.create;
     ChargeExo;

     (*calculs automatiques*)
     (* si MAxExo=0 il y a eu un problme donc l'appli se fermera sans se lancer *)
     MaxExo:=DataList.Count;
     if MaxExo>0 then NbExo:=-1;
     if MaxExo>0 then begin
        PointParExo:=100 div MaxExo;
        While PointParExo*MaxExo<100 do Inc(PointParExo);
     end else PointParExo:=0;
     (* dans la suite, le score est sur 100
        et est  mettre dans LiliScore1.Note par
        LiliScore1.Note:= .... voir procedure Verifier
     *)
     Credit:=PointParExo;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     (* a priori rien  crire ici !
        voir ChargeExo !
     *)

     (* plein cran *)
     width:=screen.width;
     height:=screen.height;

     Randomize;
     FirstRun:=true; (* pour demander le code *)
     (* charger l'exo *)
     MaxExo:=0; (*  modifier selon *)
     NbExo:=-1; (* de 0  MaxExo-1 *)
     MsgDlgGlyphs:=false;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var s : string;
begin
     (* faut-il inscrire le score ?*)
     If FirstRun then begin
        width:=10;
        height:=10;
        CanCLose:=true;
        exit;
     end;
     If not( (NbExo>=MaxExo) and (LiliScore1.Note=0)) then begin
        (*question si qq chose a t fait*)
        If (NbExo<MaxExo-1) then begin
           s:='L''exercice n''est pas termin.'#13+
              'Etes-vous sr de vouloir quitter ?'#0;
           CanClose:=CanClose and ( MessageDLg(s,mtConfirmation,[mbYes,mbNo],0)=mrYes);
           if NbExo<=0 then exit;
        end;
     end;
        If CanClose then begin
           s:='Ton score est de '+inttostr(LiliScore1.Note)+'%.'#13;
           If LiliScore1.Note>75
              then s:='Bravo !'#13+s
              else s:='Echec !'#13+s;
           s:=s+#0;
           LiliScore1.InscrireScore;
           MessageDlg(s,mtInformation,[mbOK],0);
        end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     (* avant de quitter on ferme l'ventuelle fentre d'aide *)
     Application.HelpCommand(HELP_QUIT, 0)
end;

procedure TForm1.FormShow(Sender: TObject);
begin
     (* c'est le premier affichage donc on demande le code ...*)
     If FirstRun then begin
        If LiliScore1.Identifier then begin
           ParamStr1:=ParamStr(1);
           Initialise; (* qui appelle ChargeExo !*)
           if MaxExo<=0
              then close
              else begin;
                   FirstRun:=false;
                   With LiliScore1 do LiliPanel1.caption:=Nom+' '+Prenom+' '+Classe+'   ';
                   NouvelExo;
              end;
        end else Application.terminate;
     end;
end;

procedure TForm1.LiliBitBtn1Click(Sender: TObject);
(* bouton Quitter *)
begin
     Close;
end;

procedure TForm1.LiliBitBtn2Click(Sender: TObject);
(* bouton Scores *)
begin
     LiliScore1.MontrerLeScore;
     (*LiliScore1.MontrerLesScores pour tout *)
end;

procedure TForm1.LiliBitBtn3Click(Sender: TObject);
(* bouton Aide *)
begin
     If Application.HelpFile='' then Application.HelpFile:=ChangeFileExt(Application.ExeName,'.hlp');
     Application.HelpCommand(HELP_CONTENTS, 0)
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
(* filtrage du clavier *)
begin
     (* KeyPreview de la fiche  TRUE ! *)
     (* touche F1 : aide *)
     If Key=vk_F1 then LiliBitBtn3Click(Sender);
     if ssAlt in shift then begin
        (* touche ALT+X : quitter *)
        if (key=ord('X')) then close;
     end;
end;

function TForm1.Autre : boolean;
(* si exercice en cours fini (credit = 0) on passe  l'exo suivant *)
(* possibilits d'amliorer *)
begin
     Result:=true;
     MessageDlg('Passons  la suite ...',mtWarning,[mbOK],0);
end;

(*********)
(* l'objet TList qui contient la srie d'exercices *)
(**********)

constructor TDataList.Create;
begin
     inherited Create;
end;

destructor TDataList.Destroy;
var
   i: integer;
   AData : TData;
begin
     for i:=0 to Count-1 do begin
         AData:=items[i];
         AData.Free;
     end;
     inherited Destroy;
end;

procedure TDataList.MelangeAleatoire;
var
   i,j,k : integer;
begin
     for i:=0 to 3*count do begin
         j:=random(count);
         k:=random(count);
         if j<>k then Exchange(j,k);
     end;
end;

(**********************************************************)
(* LILI: mthodes fixes  modifier pour s'adapter  l'exo *)
(**********************************************************)

(********)
(* l'objet qui contient les infos de 1 exercice *)
(**********)

constructor TData.Create;
begin
     Hypo := TStringList.Create;
     Conc := TStringList.Create;
     Figure:=TStringList.Create;
     Theo:=0;
     Essai:=0;
end;

destructor TData.Destroy;
begin
     Hypo.free;
     Conc.Free;
     Figure.Free;
end;

(********)
(* l'objet qui contient les theoremes *)
(**********)

constructor TTheoreme.Create;
begin
     numero:=0;
     enonce := TStringList.Create;
end;

destructor TTheoreme.Destroy;
begin
     Enonce.Free;
end;

(*********)
(* l'objet TForm1 fiche de base *)
(**********)

procedure TForm1.ChargeExo;
var
   i : integer;
   stl : TStringList;
   s : string;
   c : char;
begin
     (* on utilise les var globales
        DataList
        Data
        Chemin
        Paramstr1
     *)
     (* on charge les exos dans DataList *)
     (* DataList.count donnera le nb max d'exos *)
        if FileExists(ParamStr1)
           then s:=ParamStr1
           else if FileExists(chemin+ParamStr1)
                then s:=chemin+ParamStr1
                else s:=Chemin+'HypoConc.dat';

     stl:=TStringList.Create;
     try
        TheoList:=TDataList.Create;
        stl.LoadFromFile(s);
        i:=0;
        Data:=nil;
        Theoreme:=nil;
        while i<stl.count do begin
              s:=stl[i];
              if s<>'' then begin
                 if s[1]='#' then begin
                    Data:=TData.Create;
                    Data.Theo:=DataList.count;
                    Theoreme:=TTheoreme.Create;
                    Theoreme.numero:=DataList.count;
                    DataList.Add(Data);
                    TheoList.Add(Theoreme);
                 end else
                 if s[1]='[' then begin
                    c:=upcase(s[2]);
                 end else begin
                     case c of
                     'H' : Data.Hypo.Add(s);
                     'C' : Data.Conc.Add(s);
                     'F' : Data.Figure.Add(s);
                     'T' : Theoreme.enonce.add(s);
                     end;
                 end;
              end;
              inc(i);
        end;
        DataList.MelangeAleatoire;
        (*TheoList.MelangeAleatoire;*)
        Theoreme:=TheoList[0];
        Memo2.Lines.Assign(Theoreme.enonce);
        numTheos:=0;
     finally
            stl.free;
     end;
     KeopsPanel2.left:=(Panel2.Width-2*Panel2.BorderWidth-4*Panel2.BevelWidth-KeopsPanel2.width) div 2;
     KeopsPanel2.Top:=(Panel2.Height-2*Panel2.BorderWidth-4*Panel2.BevelWidth-KeopsPanel2.Height) div 2;

     KeopsPanel1.PictureFileName:=Chemin+'hypoconc.bmp';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     (* complter avec les objets globaux crs dans ChargeExo *)
     DataList.Free;
     TheoList.Free;
end;

procedure TForm1.NouvelExo;
begin
     Inc(NbExo);
     if NbExo<MaxExo then begin
        Data:=DataList[NbExo];
	      (* propager les modifs du au changement de Data *)
        Label2.Caption:='Exercice '+inttostr(NbExo+1)+' sur '+inttostr(MaxExo);
        Memo1.Lines.Assign(Data.Hypo);
        Memo3.Clear;
        ImageoPlan1.Lines.Assign(Memo3.Lines);
        (**)
        Credit:=PointParExo;
     end else Close;
end;

procedure TForm1.Verifier;
(* mthode  invoquer pour vrifier une proposition *)
var
   AuSuivant : boolean; (* passera-t-on  l'exo suivant aprs la verif ? *)

   procedure SetErreur(a : integer; t : string);
   begin
        if t<>'' then MessageDlg( t,mtWarning,[mbOK],0);
        if Credit>a
           then Credit:=Credit-a
           else begin
                Credit:=0;
                AuSuivant:=Autre
           end;
   end;

   function Comparer : boolean;
   (*  complter pour indiquer si la proposition est correcte ou pas *)
   begin
        Result:=(Theoreme.numero=Data.Theo);
   end;

begin
     AuSuivant:=false;
     Data:=DataList[NbExo];

     if Comparer then begin
          Memo3.Lines.Assign(Data.Conc);
          ImageoPlan1.Lines.Assign(Data.Figure);
          MessageDlg('Trs bien.'#13+inttostr(PointParExo)+' points marqus.',mtInformation,[mbOK],0);
          LiliScore1.note:=LiliScore1.Note+Credit;
          AuSuivant:=true;
     end else begin
         inc(Data.Essai);
         case Data.Essai of
         1 : begin
                  Memo3.Lines.Assign(Data.Conc);
                  SetErreur(PointParExo div 3+1,'Erreur : '+inttostr(PointParExo div 3+1)+
                  ' points perdus.'#13'Regarde la conclusion attendue.');
             end;
         2 : begin
                  ImageoPlan1.Lines.Assign(Data.Figure);
                  SetErreur(PointParExo div 3,'Erreur : '+inttostr(PointParExo div 3)+
                  ' points perdus.'#13'Regarde la figure associe.');
             end;
         3 : begin
                  SetErreur(PointParExo,'Erreur.'#13'Aucun point n''est accord.');
             end;
         end;
     end;

     if AuSuivant then NouvelExo;
end;

(**********)
(* LILI: autres mthodes cres  partir du projet de base *)
(**********)

procedure TForm1.BitBtn4Click(Sender: TObject);
(* bouton Vrifier *)
begin
     Verifier;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
     if NumTheos>=TheoList.count-1 then NumTheos:=-1;
     inc(NumTheos);
     Theoreme:=TheoList[NumTheos];
     Memo2.Lines.Assign(Theoreme.enonce);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
     if NumTheos<=0 then NumTheos:=TheoList.count;
     dec(NumTheos);
     Theoreme:=TheoList[NumTheos];
     Memo2.Lines.Assign(Theoreme.enonce);
end;

end.
